package se.umu.jobsubmission.impl.broker;

import org.ggf.schemas.jsdl._2005._11.jsdl.JobDefinition_Type;
import org.globus.gsi.GlobusCredential;

import se.umu.jobsubmission.JobPreferencesType;

public interface Predictor {

	/**
	 * 
	 * @param jobDescription The description of the job in JSDL format. 
	 * @param resource The resource we are prediciting the task time for. 
	 * @param preferences User's job preferences
	 * @param context Parameters specific to this predictor
	 * @return the predicted duration of the task. 
	 */
    public int predict(JobDefinition_Type jobDescription, 
    		Object resource, 
    		JobPreferencesType preferences, 
			Object context, 
			GlobusCredential credential); //  throws Exception; 

}
