package org.nordugrid.job.mds;

import javax.naming.Context;
import javax.naming.directory.InitialDirContext;
import javax.naming.directory.DirContext;
import javax.naming.directory.SearchControls;
import javax.naming.NamingEnumeration;
import javax.naming.NamingException; 
import javax.naming.directory.Attributes;
import javax.naming.directory.Attribute;
import javax.naming.directory.SearchResult; 

import java.util.Hashtable;
import java.util.List;
import java.util.LinkedList;

public class ARCMDSResources {

    private List resources = new LinkedList();

    public ARCMDSResources() {
    }

    public int size() {
        return resources.size();
    }

    public ARCMDSResource get(int i) {
        return (ARCMDSResource)(resources.get(i));
    }

    public void add(String url,String user) {
        // Run query
        try {
            Hashtable env = new Hashtable();
            env.put(Context.INITIAL_CONTEXT_FACTORY,
                          "com.sun.jndi.ldap.LdapCtxFactory");
            env.put(Context.PROVIDER_URL,url);
            DirContext ctx = new InitialDirContext(env);
            // String[] needed_attrs = { "giisregistrationstatus" };
            SearchControls controls = new SearchControls();
            controls.setCountLimit(0);
            controls.setTimeLimit(10000);
            controls.setSearchScope(SearchControls.SUBTREE_SCOPE);
            // controls.setReturningAttributes(needed_attrs);
            String filter = 
                 "(|"+
                   "(objectclass=nordugrid-cluster)"+
                   "(&"+
                     "(objectclass=nordugrid-queue)"+
                     "(nordugrid-queue-status=active)"+
                   ")"+
                   "(&"+
                     "(objectclass=nordugrid-authuser)"+
                     "(nordugrid-authuser-sn="+user+")"+
                   ")"+
                 ")";
            NamingEnumeration resultp =
                          ctx.search("",filter,controls);
            Attributes cluster = null;
            Attributes queue = null;
            Attributes authuser = null;
            for(;resultp.hasMore();) {
                try {
                    SearchResult result = (SearchResult)(resultp.next());
//System.err.println("RESULT: "+result.toString());
                    Attributes attrs = result.getAttributes();
                    Attribute attr = attrs.get("objectClass");
                    String oclass = null;
                    for(int i=0;i<attrs.size();i++) {
                        oclass=(String)(attrs.get("objectClass").get(i));
                        if(oclass.equals("nordugrid-cluster")) {
                            cluster=attrs; break;
                        } else if(oclass.equals("nordugrid-queue")) {
                            queue=attrs; break;
                        } else if(oclass.equals("nordugrid-authuser")) {
                            authuser=attrs;
                            ARCMDSResource r =
                                   new ARCMDSResource(cluster,queue,authuser);
                            resources.add(r);
                            break;
                        }
                    }
                } catch(java.lang.Exception err) {
                    System.err.println("Error: "+err.toString());
                    continue;
                }                  
            }
        } catch (NamingException err) {
            System.err.println("Error: "+err.toString());
        }

    }
}
